<template>
  <div class="confirm-dialog">
    <button class="button" :class="[ buttonClass ? buttonClass : &quot;is-primary&quot; ]"
      :disabled="disabled" @click.prevent="open">{{ buttonTitle }}
    </button>
      <div class="modal" :class="{ &quot;is-active&quot;: active || loading }">
          <div class="modal-background"></div>
          <div class="modal-card content" :class="{ &quot;modal-large&quot;: isLarge }">
              <header class="modal-card-head">
                  <p class="modal-card-title">{{ title }}</p>
              </header>
              <section class="modal-card-body">
                  <slot></slot>
              </section>
              <slot name="footer">
                  <footer class="modal-card-foot">
                    <button class="button" v-if="buttonAction"
                      :class="[ buttonClass ? buttonClass :
                        &quot;is-primary&quot; , loading ? &quot;is-loading&quot; : &quot;&quot;]"
                      @click.prevent="confirm" :disabled="disabledSave">{{buttonActionName}}
                    </button>
                    <button class="button"
                      @click.prevent="close"
                      :disabled="loading">Cerrar
                    </button>
                  </footer>
              </slot>
          </div>
      </div>
  </div>
</template>

<script>

export default {
  name: 'Modal',
  data() {
    return {
      active: false,
    };
  },
  props: {
    title: null,
    buttonTitle: null,
    buttonClass: null,
    buttonAction: {
      type: Boolean,
      default: true,
    },
    buttonActionName: {
      type: String,
      default: 'Guardar',
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    loading: Boolean,
    disabledSave: {
      type: Boolean,
      default: false,
    },
    isLarge: {
      type: Boolean,
      default: false,
    },
    isAuto: {
      type: Boolean,
      default: true,
    },
  },
  methods: {
    confirm() {
      this.$emit('confirmed');
      if (this.isAuto) {
        this.active = false;
      }
    },
    close() {
      this.$emit('close');
      this.active = false;
    },
    open() {
      this.$emit('open');
      this.active = true;
    },
  },
};
</script>

<style scoped>
  .modal-large {
    width: 80vw;
  }
  .content {
    min-height: 60vh;
  }
</style>
